{ stdenv, fetchgit, python3Packages, nmigen, git }:

python3Packages.buildPythonPackage {
  name = "nmigen-boards";
  version = "2019-10-13";

  src = fetchgit {
    # Using official master branch
    #url = "https://github.com/m-labs/nmigen-boards";
    #rev = "bc074915d6c67a33447d4730b720b37e3ea4bb3f";
    #sha256 = "1qp32783p0bg6fxfj0wd7fd3if8az7w1r521wcbznxakdrqhrqjd";

    # Using harry's fork
    url = "https://github.com/HarryHo90sHK/nmigen-boards";
    rev = "d51e1d5f53aca59d138860d332edf84fdce7cfa3";
    sha256 = "0yfs81bhcx4pm4q83pjhiibc1zknsllimqb2c753r3vvbcg4frmw";

    leaveDotGit = true;
  };

  nativeBuildInputs = [ python3Packages.setuptools_scm git ];
  propagatedBuildInputs = [ nmigen ];

  meta = with stdenv.lib; {
    description = "Board and connector definition files for nMigen";
    homepage    = "https://m-labs.hk";
    license     = licenses.bsd2;
    maintainers = [ maintainers.sb0 ];
  };
}
